import 'package:chat_app/helpers/mostrar_alerta.dart';
import 'package:chat_app/services/auth_service.dart';

import 'package:flutter/material.dart';
import 'package:chat_app/widgets/widgets_export.dart';
import 'package:provider/provider.dart';

class LoginPage extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
        backgroundColor: Color(0xffF2F2F2),
        body: SafeArea(
          child: SingleChildScrollView(
            physics: BouncingScrollPhysics(),
            child: Container(
              height: MediaQuery.of(context).size.height * 0.9,
              child: Column(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: <Widget>[
                  Logo(titulo: 'Chating'),
                  _Form(),
                  Labels(
                    ruta: 'register',
                    titulo: 'Aún no tienes cuenta?',
                    subTitulo: 'Creamos una ahora!!',
                  ),
                  Text(
                    'Términos y condiciones de uso',
                    style: TextStyle(fontWeight: FontWeight.w200),
                  )
                ],
              ),
            ),
          ),
        ));
  }
}

class _Form extends StatefulWidget {
  @override
  __FormState createState() => __FormState();
}

class __FormState extends State<_Form> {
  final emailCtrl = TextEditingController();
  final passCtrl = TextEditingController();

  @override
  Widget build(BuildContext context) {
    final authService = Provider.of<AuthService>(context);

    return Container(
      margin: EdgeInsets.only(top: 40),
      padding: EdgeInsets.symmetric(horizontal: 50),
      child: Column(
        children: <Widget>[
          CustomInput(
            icon: Icons.email_outlined,
            placeholder: 'Email',
            keyboardType: TextInputType.emailAddress,
            textController: emailCtrl,
          ),
          CustomInput(
            icon: Icons.lock_outlined,
            placeholder: 'Password',
            textController: passCtrl,
            isPassword: true,
          ),
          LoginButton(
            text: 'Ingresar',
            onPressed: () async {
              FocusScope.of(context).unfocus();
              final loginOk = await authService.login(
                  emailCtrl.text.trim(), passCtrl.text.trim());

              if (loginOk) {
                //TODO: Conectar a nuestro Socket Server
                Navigator.pushReplacementNamed(context, 'usuarios');
              } else {
                //Mostrar Alerta
                mostrarAlerta(
                    context, 'Login incorrecto', 'Revise sus credenciales');
              }
            },
          ),
        ],
      ),
    );
  }
}
